#include "ncbind/ncbind.hpp"
#include <stdio.h>
#define _USE_MATH_DEFINES
#include <math.h>

/**
 * Oo͗p
 */
static void log(const tjs_char *format, ...)
{
	va_list args;
	va_start(args, format);
	tjs_char msg[1024];
	_vsnwprintf(msg, 1024, format, args);
	TVPAddLog(msg);
	va_end(args);
}

#include "layerExBase.hpp"

/*
 * AEgCx[X̃eLXg`惁\bh̒ǉ
 */
struct layerExRaster : public layerExBase
{
public:
	// RXgN^
	layerExRaster(DispatchT obj) : layerExBase(obj) {}

	/**
	 * X^[Rs[
	 * @param layer `挳C
	 * @param maxh  őU(pixel)
	 * @param lines P胉C
	 * @param cycle w(msec)
	 * @param time ݎ
	 */
	void copyRaster(tTJSVariant layer, int maxh, int lines, int cycle, tjs_int64 time) {
		
		_width;
		_height;
		_buffer;
		_pitch;
		
		// C摜
		tjs_int width, height, pitch;
		unsigned char* buffer;
		{
			iTJSDispatch2 *layerobj = layer.AsObjectNoAddRef();
			tTJSVariant var;
			layerobj->PropGet(0, L"imageWidth", NULL, &var, layerobj);
			width = (tjs_int)var;
			layerobj->PropGet(0, L"imageHeight", NULL, &var, layerobj);
			height = (tjs_int)var;
			layerobj->PropGet(0, L"mainImageBuffer", NULL, &var, layerobj);
			buffer = (unsigned char*)(tjs_int)var;
			layerobj->PropGet(0, L"mainImageBufferPitch", NULL, &var, layerobj);
			pitch = (tjs_int)var;
		}

		if (_width != width || _height != height) {
			return;
		}

		// pxvZ
		double omega = 2 * M_PI / lines;
		
		//double tt = sin((3.14159265358979/2.0) * time / cycle);
		//tjs_int CurH = (tjs_int)(tt * maxh);
		tjs_int CurH = (tjs_int)maxh;
		
		// p[^vZ
		double rad = - omega * time / cycle * (height/2);
		
		// CƂɏ
		tjs_int n;
		for (n = 0; n < height; n++, rad += omega) {
			tjs_int d = (tjs_int)(sin(rad) * CurH);
			if (d >= 0) {
				int w = width - d;
				const tjs_uint32 *src = (const tjs_uint32*)(buffer + n * pitch);
				tjs_uint32 *dest = (tjs_uint32 *)(_buffer + n * _pitch) + d;
				for (tjs_int i=0;i<w;i++) {
					*dest++ = *src++;
				}
			} else {
				int w = width + d;
				const tjs_uint32 *src = (const tjs_uint32*)(buffer + n * pitch) - d;
				tjs_uint32 *dest = (tjs_uint32 *)(_buffer + n * _pitch);
				for (tjs_int i=0;i<w;i++) {
					*dest++ = *src++;
				}
			}
		}

//		redraw();
	}
};

// ----------------------------------- NX̓o^

NCB_GET_INSTANCE_HOOK(layerExRaster)
{
	// CX^XQb^
	NCB_INSTANCE_GETTER(objthis) { // objthis  iTJSDispatch2* ^̈Ƃ
		ClassT* obj = GetNativeInstance(objthis);	// lCeBuCX^X|C^擾
		if (!obj) {
			obj = new ClassT(objthis);				// Ȃꍇ͐
			SetNativeInstance(objthis, obj);		// objthis  obj lCeBuCX^XƂēo^
		}
		obj->reset();
		return obj;
	}
	// fXgN^iۂ̃\bhĂ΂ꂽɌĂ΂j
	~NCB_GET_INSTANCE_HOOK_CLASS () {
	}
};


// tbNA^b`
NCB_ATTACH_CLASS_WITH_HOOK(layerExRaster, Layer) {
	NCB_METHOD(copyRaster);
}
